--TEST--
int MySQLndUhConnection::getErrorNumber(resource $connection)
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	class proxy extends MySQLndUhConnection {
		public function getErrorNumber($res) {
			printf("%s(%s)\n", __METHOD__, var_export(func_get_args(), true));
			var_dump($ret = parent::getErrorNumber($res));
			return $ret;
		}
	}

	class proxy2 extends MySQLndUhConnection {
		public function getErrorNumber($res) {
			return 12;
		}
	}

	class proxy3 extends MySQLndUhConnection {
		public function getErrorNumber($res) {
			$ret = new stdClass();
			return $ret;
		}
	}

	class proxy4 extends MySQLndUhConnection {
		public function getErrorNumber($res) {}
	}

	class proxy5 extends MySQLndUhConnection {
		public function getErrorNumber($res) {
			return PHP_INT_MAX;
		}
	}

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_test\query_test::mysqli($conn);
	$conn->kill($conn->thread_id);
	var_dump($conn->query("SELECT 1 FROM DUAL"));
	$errno = $conn->errno;

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_set_connection_proxy(new proxy());
	mysqlnd_uh_test\query_test::mysqli($conn);
	$conn->kill($conn->thread_id);
	var_dump($conn->query("SELECT 1 FROM DUAL"));

	if (($tmp = $conn->errno) != $errno)
		printf("[001] Errno has changed from %d to %d\n", $errno, $tmp);

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_set_connection_proxy(new proxy2());
	var_dump($conn->errno);

	mysqlnd_uh_set_connection_proxy(new proxy3());
	var_dump($conn->errno);

	mysqlnd_uh_set_connection_proxy(new proxy4());
	var_dump($conn->errno);
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy5());
	var_dump($conn->errno);

	print "done!";
?>
--EXPECTF--
bool(false)
bool(false)
proxy::getErrorNumber(array (
  0 => NULL,
))
int(2006)
proxy::getErrorNumber(array (
  0 => NULL,
))
int(0)
int(12)

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getErrorNumber() did not return a numeric value as it should (C type used by mysqlnd: "unsigned int") in %s on line %d
int(2)

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getErrorNumber() did not return a numeric value as it should (C type used by mysqlnd: "unsigned int") in %s on line %d
int(0)
int(%d)
done!
