--TEST--
string MySQLndUhConnection::getHostInformation(resource $connection)
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	class proxy extends MySQLndUhConnection {
		public function getHostInformation($res) {
			printf("%s(%s)\n", __METHOD__, var_export(func_get_args(), true));
			var_dump($ret = parent::getHostInformation($res));
			return $ret;
		}
	}

	class proxy2 extends MySQLndUhConnection {
		public function getHostInformation($res) {
			return "my host info!";
		}
	}

	class proxy3 extends MySQLndUhConnection {
		public function getHostInformation($res) {
			return false;
		}
	}

	class proxy4 extends MySQLndUhConnection {
		public function getHostInformation($res) {
			return "";
		}
	}

	class proxy5 extends MySQLndUhConnection {
		public function getHostInformation($res) {}
	}

	class proxy6 extends MySQLndUhConnection {
		public function getHostInformation($res) { return str_repeat("a", 4096); }
	}

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_test\query_test::mysqli($conn);
	$org = $conn->host_info;

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_set_connection_proxy(new proxy());
	mysqlnd_uh_test\query_test::mysqli($conn);

	if (($tmp = $conn->host_info) != $org)
		printf("[001] Host info has changed from %s to %s\n", $org, $tmp);

	mysqlnd_uh_set_connection_proxy(new proxy2());
	var_dump($conn->host_info);


	mysqlnd_uh_set_connection_proxy(new proxy3());
	var_dump($conn->host_info);
	var_dump($conn->host_info);

	mysqlnd_uh_set_connection_proxy(new proxy4());
	var_dump($conn->host_info);

	mysqlnd_uh_set_connection_proxy(new proxy5());
	var_dump($conn->host_info);

	mysqlnd_uh_set_connection_proxy(new proxy6());
	var_dump($conn->host_info);

	print "done!";
?>
--EXPECTF--
proxy::getHostInformation(array (
  0 => NULL,
))
string(%d) "%s"
string(13) "my host info!"

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getHostInformation() did not return a string value as it should in %s on line %d
NULL

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getHostInformation() did not return a string value as it should in %s on line %d
NULL
string(0) ""

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getHostInformation() did not return a string value as it should in %s on line %d
NULL

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getHostInformation() should not return a string longer than MYSQLND_UH_HOST_INFO_LENGTH - 1 characters. The return value will be trimmed in %s on line %d
string(%d) "%s"
done!