--TEST--
int MySQLndUhConnection::getLastInsertId(resource $connection)
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	class proxy extends MySQLndUhConnection {
		public function getLastInsertId($res) {
			printf("%s(%s)\n", __METHOD__, var_export(func_get_args(), true));
			var_dump($ret = parent::getLastInsertId($res));
			return $ret;
		}
	}

	class proxy2 extends MySQLndUhConnection {
		public function getLastInsertId($res) {
			return 12;
		}
	}

	class proxy3 extends MySQLndUhConnection {
		public function getLastInsertId($res) {
			$ret = new stdClass();
			return $ret;
		}
	}

	class proxy4 extends MySQLndUhConnection {
		public function getLastInsertId($res) {}
	}

	class proxy5 extends MySQLndUhConnection {
		public function getLastInsertId($res) {
			return PHP_INT_MAX;
		}
	}

	function test_last_insert_id($conn, $offset, $next) {
		if (!$conn->query(sprintf("INSERT INTO test(col1) VALUES (%d)", $next))) {
			printf("[%03d] [%d] '%s'\n", $offset, $conn->errno, $conn->error);
			return $next;
		}
		if ($next != $conn->insert_id) {
			printf("[%03d] Expecting %d got %s\n", $offset + 1, $next, $conn->insert_id);
			return $next;
		}
		return ++$next;
	}

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_test\query_test::mysqli($conn);
	if (!$conn->query("DROP TABLE IF EXISTS test")
		|| !$conn->query("CREATE TABLE test(id INT NOT NULL PRIMARY KEY AUTO_INCREMENT, col1 INT)"))
		printf("[001] [%d] '%s'\n", $conn->errno, $conn->error);

	test_last_insert_id($conn, 2, 1);
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy());
	test_last_insert_id($conn, 4, 2);
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy2());
	test_last_insert_id($conn, 6, 12);
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy3());
	test_last_insert_id($conn, 8, 3);
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy4());
	test_last_insert_id($conn, 10, 0);
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy5());
	test_last_insert_id($conn, 12, PHP_INT_MAX);
	mysqlnd_uh_test\query_test::mysqli($conn);

	print "done!";
?>
--EXPECTF--
proxy::getLastInsertId(array (
  0 => NULL,
))
int(%d)

Warning: test_last_insert_id(): (MySQLnd User Handler) The method MySQLndUhConnection::getLastInsertId() did not return a numeric value as it should (C type used by mysqlnd: "uint64_t") in %s on line %d

Warning: test_last_insert_id(): (MySQLnd User Handler) The method MySQLndUhConnection::getLastInsertId() did not return a numeric value as it should (C type used by mysqlnd: "uint64_t") in %s on line %d
done!