--TEST--
int MySQLndUhConnection::getServerVersion(resource $connection)
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	class proxy extends MySQLndUhConnection {
		public function getServerVersion($res) {
			printf("%s(%s)\n", __METHOD__, var_export(func_get_args(), true));
			var_dump($ret = parent::getServerVersion($res));
			return $ret;
		}
	}

	class proxy2 extends MySQLndUhConnection {
		public function getServerVersion($res) {
			return "my server version";
		}
	}

	class proxy3 extends MySQLndUhConnection {
		public function getServerVersion($res) {
			return $res;
		}
	}

	class proxy4 extends MySQLndUhConnection {
		public function getServerVersion($res) {}
	}

	class proxy5 extends MySQLndUhConnection {
		public function getServerVersion($res) {
			return PHP_INT_MAX;
		}
	}

	class proxy6 extends MySQLndUhConnection {
		public function getServerVersion($res) {
			return -1;
		}
	}

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_test\query_test::mysqli($conn);
	$org = $conn->server_version;

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_set_connection_proxy(new proxy());
	mysqlnd_uh_test\query_test::mysqli($conn);

	if (($tmp = $conn->server_version) != $org)
		printf("[001] Server version has changed from %s to %s\n", $org, $tmp);

	mysqlnd_uh_set_connection_proxy(new proxy2());
	var_dump($conn->server_version);

	mysqlnd_uh_set_connection_proxy(new proxy3());
	var_dump($conn->server_version);

	mysqlnd_uh_set_connection_proxy(new proxy4());
	var_dump($conn->server_version);

	mysqlnd_uh_set_connection_proxy(new proxy5());
	var_dump($conn->server_version);

	mysqlnd_uh_set_connection_proxy(new proxy6());
	var_dump($conn->server_version);

	print "done!";
?>
--EXPECTF--
proxy::getServerVersion(array (
  0 => NULL,
))
int(%d)
int(%d)

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getServerVersion() did not return a numeric value as it should (C type used by mysqlnd: "unsigned long") in %s on line %d
int(7)

Warning: main(): (MySQLnd User Handler) The method MySQLndUhConnection::getServerVersion() did not return a numeric value as it should (C type used by mysqlnd: "unsigned long") in %s on line %d
int(0)
string(%d) "%d"
string(%d) "%d"
done!