--TEST--
bool MySQLndUhConnection::selectDb(resource $connection, string $table, string $achtung_wild)
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	class proxy extends MySQLndUhConnection {
		public function listFields($res, $table, $pattern) {
			printf("%s(%s)\n", __METHOD__, var_export(func_get_args(), true));
			var_dump($ret = parent::listFields($res, $table, $pattern));
			return $ret;
		}
	}

	class proxy2 extends MySQLndUhConnection {
		public function listFields($res, $table, $pattern) {
			/* NOTE: it is not possible to detect the wrong resource type ! */
			return $res;
		}
	}

	class proxy3 extends MySQLndUhConnection {
		public function listFields($res, $table, $pattern) {}
	}

	class proxy4 extends MySQLndUhConnection {
		public function listFields($res, $table, $pattern) {
			return -1;
		}
	}

	function test_list_fields($conn, $offset) {
		printf("mysql_list_fields(%s, %s)\n", MYSQLND_UH_TEST_MYSQL_DB, "test_fields");
		$res = mysql_list_fields(MYSQLND_UH_TEST_MYSQL_DB, "test_fields", $conn);
		if (!$res) {
			printf("[%03d] [%d] '%s'\n", $offset, mysql_errno($conn), mysql_error($conn));
			return false;
		}

		var_dump(mysql_num_rows($res));
		while ($row = mysql_fetch_assoc($res))
			var_dump($row);
		mysql_free_result($res);
	}

	$conn = mysqlnd_uh_test\connect::mysql();
	if (!mysql_query("DROP TABLE IF EXISTS test_fields", $conn)
		|| !mysql_query("CREATE TABLE test_fields(id INT, email CHAR(40))", $conn)
		|| !mysql_query("INSERT INTO test_fields(id, email) VALUES (1, 'spam@me.com')", $conn))
		printf("[001] [%d] '%s'\n", mysql_errno($conn), mysql_error($conn));
	test_list_fields($conn, 2);
	mysqlnd_uh_test\query_test::mysql($conn);

	mysqlnd_uh_set_connection_proxy(new proxy());
	test_list_fields($conn, 3);
	mysqlnd_uh_test\query_test::mysql($conn);

	mysqlnd_uh_set_connection_proxy(new proxy2());
	test_list_fields($conn, 4);
	mysqlnd_uh_test\query_test::mysql($conn);

	mysqlnd_uh_set_connection_proxy(new proxy3());
	test_list_fields($conn, 5);
	mysqlnd_uh_test\query_test::mysql($conn);

	mysqlnd_uh_set_connection_proxy(new proxy4());
	test_list_fields($conn, 6);
	mysqlnd_uh_test\query_test::mysql($conn);

	print "done!";
?>
--CLEAN--
<?php
require_once('config.inc');
$conn = mysqlnd_uh_test\connect::mysqli();
$conn->query("DROP TABLE IF EXISTS test_fields");
?>
--EXPECTF--
mysql_list_fields(test, test_fields)
int(0)
mysql_list_fields(test, test_fields)
proxy::listFields(array (
  0 => NULL,
  1 => 'test_fields',
  2 => '',
))
resource(%d) of type (MySQLnd Resultset (internal only - you must not modify it!))
int(0)
mysql_list_fields(test, test_fields)

Warning: mysql_list_fields(): Unable to save MySQL query result in %s on line %d
[004] [0] ''
mysql_list_fields(test, test_fields)

Warning: mysql_list_fields(): Unable to save MySQL query result in %s on line %d
[005] [0] ''
mysql_list_fields(test, test_fields)

Warning: mysql_list_fields(): Unable to save MySQL query result in %s on line %d
[006] [0] ''
done!