--TEST--
bool MySQLndUhConnection::sendClose(resource $connection)
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	class proxy extends MySQLndUhConnection {
		public function sendClose($conn) {
			printf("%s(%s)\n", __METHOD__, var_export(func_get_args(), true));
			return parent::sendClose($conn);
		}
	}

	class proxy2 extends MySQLndUhConnection {
		public function sendClose($conn) {
			return $conn;
		}
	}

	class proxy3 extends MySQLndUhConnection {
		public function sendClose($conn) {}
	}

	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_test\query_test::mysqli($conn);

	mysqlnd_uh_set_connection_proxy(new proxy());
	mysqlnd_uh_test\query_test::mysqli($conn);
	$conn->close();

	mysqlnd_uh_set_connection_proxy(new proxy2());
	$conn = mysqlnd_uh_test\connect::mysqli();
	$conn->close();

	mysqlnd_uh_set_connection_proxy(new proxy3());
	$conn = mysqlnd_uh_test\connect::mysqli();
	mysqlnd_uh_test\query_test::mysqli($conn);
	$conn->close();

	print "done!";
?>
--EXPECTF--
proxy::sendClose(array (
  0 => NULL,
))
proxy::sendClose(array (
  0 => NULL,
))

Warning: MySQLndUhConnection::close(): (MySQLnd User Handler) The method MySQLndUhConnection::sendClose() did not return a boolean value as it should in %s on line %d

Warning: MySQLndUhConnection::close(): (MySQLnd User Handler) The method MySQLndUhConnection::sendClose() did not return a boolean value as it should in %s on line %d

Warning: MySQLndUhConnection::close(): (MySQLnd User Handler) The method MySQLndUhConnection::sendClose() did not return a boolean value as it should in %s on line %d

Warning: MySQLndUhConnection::close(): (MySQLnd User Handler) The method MySQLndUhConnection::sendClose() did not return a boolean value as it should in %s on line %d
done!