--TEST--
PHP constants
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	$constants = get_defined_constants(false);
	$mysqlnd_uh_constants = array();
	foreach ($constants as $name => $value) {
		if (substr($name, 0, 10) != "MYSQLND_UH")
			continue;

		$mysqlnd_uh_constants[$name] = $value;
	}

	ksort($mysqlnd_uh_constants);
	foreach ($mysqlnd_uh_constants as $name => $value)
		printf("%s = %s\n", $name, $value);

	print "done!";
?>
--EXPECTF--
MYSQLND_UH_MYSQLND_CHG_USER_RESP_PACKET = %d
MYSQLND_UH_MYSQLND_CLOSE_DISCONNECTED = %d
MYSQLND_UH_MYSQLND_CLOSE_EXPLICIT = %d
MYSQLND_UH_MYSQLND_CLOSE_IMPLICIT = %d
MYSQLND_UH_MYSQLND_CLOSE_LAST = %d
MYSQLND_UH_MYSQLND_COM_BINLOG_DUMP = %d
MYSQLND_UH_MYSQLND_COM_CHANGE_USER = %d
MYSQLND_UH_MYSQLND_COM_CONNECT = %d
MYSQLND_UH_MYSQLND_COM_CONNECT_OUT = %d
MYSQLND_UH_MYSQLND_COM_CREATE_DB = %d
MYSQLND_UH_MYSQLND_COM_DAEMON = %d
MYSQLND_UH_MYSQLND_COM_DEBUG = %d
MYSQLND_UH_MYSQLND_COM_DELAYED_INSERT = %d
MYSQLND_UH_MYSQLND_COM_DROP_DB = %d
MYSQLND_UH_MYSQLND_COM_END = %d
MYSQLND_UH_MYSQLND_COM_FIELD_LIST = %d
MYSQLND_UH_MYSQLND_COM_INIT_DB = %d
MYSQLND_UH_MYSQLND_COM_PING = %d
MYSQLND_UH_MYSQLND_COM_PROCESS_INFO = %d
MYSQLND_UH_MYSQLND_COM_PROCESS_KILL = %d
MYSQLND_UH_MYSQLND_COM_QUERY = %d
MYSQLND_UH_MYSQLND_COM_QUIT = %d
MYSQLND_UH_MYSQLND_COM_REFRESH = %d
MYSQLND_UH_MYSQLND_COM_REGISTER_SLAVED = %d
MYSQLND_UH_MYSQLND_COM_SET_OPTION = %d
MYSQLND_UH_MYSQLND_COM_SHUTDOWN = %d
MYSQLND_UH_MYSQLND_COM_SLEEP = %d
MYSQLND_UH_MYSQLND_COM_STATISTICS = %d
MYSQLND_UH_MYSQLND_COM_STMT_CLOSE = %d
MYSQLND_UH_MYSQLND_COM_STMT_EXECUTE = %d
MYSQLND_UH_MYSQLND_COM_STMT_FETCH = %d
MYSQLND_UH_MYSQLND_COM_STMT_PREPARE = %d
MYSQLND_UH_MYSQLND_COM_STMT_RESET = %d
MYSQLND_UH_MYSQLND_COM_STMT_SEND_LONG_DATA = %d
MYSQLND_UH_MYSQLND_COM_TABLE_DUMP = %d
MYSQLND_UH_MYSQLND_COM_TIME = %d
MYSQLND_UH_MYSQLND_OPTION_INIT_COMMAND = %d
MYSQLND_UH_MYSQLND_OPTION_OPT_COMPRESS = %d
MYSQLND_UH_MYSQLND_OPTION_OPT_CONNECT_TIMEOUT = %d
MYSQLND_UH_MYSQLND_OPTION_OPT_NAMED_PIPE = %d
MYSQLND_UH_MYSQLND_OPT_GUESS_CONNECTION = %d
MYSQLND_UH_MYSQLND_OPT_INT_AND_FLOAT_NATIVE = %d
MYSQLND_UH_MYSQLND_OPT_LOCAL_INFILE = %d
MYSQLND_UH_MYSQLND_OPT_NET_CMD_BUFFER_SIZE = %d
MYSQLND_UH_MYSQLND_OPT_NET_READ_BUFFER_SIZE = %d
MYSQLND_UH_MYSQLND_OPT_PROTOCOL = %d
MYSQLND_UH_MYSQLND_OPT_READ_TIMEOUT = %d
MYSQLND_UH_MYSQLND_OPT_RECONNECT = %d
MYSQLND_UH_MYSQLND_OPT_SSL_CA = %d
MYSQLND_UH_MYSQLND_OPT_SSL_CAPATH = %d
MYSQLND_UH_MYSQLND_OPT_SSL_CERT = %d
MYSQLND_UH_MYSQLND_OPT_SSL_CIPHER = %d
MYSQLND_UH_MYSQLND_OPT_SSL_KEY = %d
MYSQLND_UH_MYSQLND_OPT_SSL_PASSPHRASE = %d
MYSQLND_UH_MYSQLND_OPT_SSL_VERIFY_SERVER_CERT = %d
MYSQLND_UH_MYSQLND_OPT_USE_EMBEDDED_CONNECTION = %d
MYSQLND_UH_MYSQLND_OPT_USE_REMOTE_CONNECTION = %d
MYSQLND_UH_MYSQLND_OPT_USE_RESULT = %d
MYSQLND_UH_MYSQLND_OPT_WRITE_TIMEOUT = %d
MYSQLND_UH_MYSQLND_PREPARE_RESP_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_AUTH_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_CMD_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_EOF_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_GREET_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_LAST = %d
MYSQLND_UH_MYSQLND_PROT_OK_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_ROW_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_RSET_FLD_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_RSET_HEADER_PACKET = %d
MYSQLND_UH_MYSQLND_PROT_STATS_PACKET = %d
MYSQLND_UH_MYSQLND_READ_DEFAULT_FILE = %d
MYSQLND_UH_MYSQLND_READ_DEFAULT_GROUP = %d
MYSQLND_UH_MYSQLND_REPORT_DATA_TRUNCATION = %d
MYSQLND_UH_MYSQLND_SECURE_AUTH = %d
MYSQLND_UH_MYSQLND_SET_CHARSET_DIR = %d
MYSQLND_UH_MYSQLND_SET_CHARSET_NAME = %d
MYSQLND_UH_MYSQLND_SET_CLIENT_IP = %d
MYSQLND_UH_MYSQLND_SHARED_MEMORY_BASE_NAME = %d
MYSQLND_UH_SERVER_OPTION_MULTI_STATEMENTS_OFF = %d
MYSQLND_UH_SERVER_OPTION_MULTI_STATEMENTS_ON = %d
MYSQLND_UH_VERSION = %s
MYSQLND_UH_VERSION_STR = %s
done!