--TEST--
PHP configuration settings
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	define("PHP_INI_USER", 1);
	define("PHP_INI_PERDIR", 6);
	define("PHP_INI_SYSTEM", 4);
	define("PHP_INI_ALL", 7);

	$settings = ini_get_all("mysqlnd_uh", true);
	arsort($settings);

	foreach ($settings as $key => $value) {
		$access = 'unknown';
		switch ($value['access']) {
			case PHP_INI_USER:
				$access = 'PHP_INI_USER';
				break;
			case PHP_INI_PERDIR:
				$access = 'PHP_INI_PERDIR';
				break;
			case PHP_INI_SYSTEM:
				$access = 'PHP_INI_SYSTEM';
				break;
			case PHP_INI_ALL:
				$access = 'PHP_INI_ALL';
				break;
			default:
				printf("[001] Unknown access level %d\n", $value['access']);
				break;
		}
		printf("%s - global: '%s'/%s - local: '%s'/%s - access: %s\n",
			$key,
			$value['global_value'], gettype($value['global_value']),
			$value['local_value'], gettype($value['local_value']),
			$access
		);
	}

	print "done!";
?>
--EXPECTF--
mysqlnd_uh.report_wrong_types - global: '1'/string - local: '1'/string - access: PHP_INI_SYSTEM
mysqlnd_uh.enabled - global: '1'/string - local: '1'/string - access: PHP_INI_SYSTEM
done!