--TEST--
bool mysqlnd_uh_set_connection_proxy(object MySQLndUhConnection[, mysqli connection])
--SKIPIF--
<?php require_once('skipif.inc'); ?>
--FILE--
<?php
	require_once('config.inc');

	if (($tmp = @mysqlnd_uh_set_connection_proxy()) != NULL) {
		printf("[001] Expecting NULL got %s\n", var_export($tmp, true));
	}

	/* "/&"/& Catchable... - &%% modern bloat */
	$obj = new stdClass();
	function my_error_handler($type, $msg, $file, $line) {
		switch ($type) {
			case E_WARNING:
			case E_RECOVERABLE_ERROR:
				break;
			default:
				printf("%d - %s in %s on line %d\n", $type, $msg, $file, $line);
				break;
		}
	}
	set_error_handler("my_error_handler");
	if (($tmp = @mysqlnd_uh_set_connection_proxy($obj)) != NULL) {
		printf("[002] Expecting NULL got %s\n", var_export($tmp, true));
	}
	restore_error_handler();

	$proxy = new MySQLndUhConnection();
	if (true !== ($tmp = mysqlnd_uh_set_connection_proxy($proxy)))
		printf("[003] Expecting true got %s\n", var_export($tmp, true));

	if (true !== ($tmp = mysqlnd_uh_set_connection_proxy($proxy)))
		printf("[004] Expecting true got %s\n", var_export($tmp, true));

	unset($proxy);

	if (true !== ($tmp = mysqlnd_uh_set_connection_proxy(new MySQLndUhConnection)))
		printf("[005] Expecting true got %s\n", var_export($tmp, true));

	class myproxy extends MySQLndUhConnection {
		public function init($res) {
			printf("%s(%s)\n", __METHOD__, var_export($res, true));
			return parent::init($res);
		}
		public function query($res, $sql) {
			printf("%s(%s, %s)\n", __METHOD__, var_export($res, true), var_export($sql, true));
			return parent::query($res, $sql);
		}
	}
	$proxy = new myproxy;

	if (true !== ($tmp = mysqlnd_uh_set_connection_proxy($proxy)))
		printf("[006] Expecting true got %s\n", var_export($tmp, true));

	$proxy2 = $proxy;
	if (true !== ($tmp = mysqlnd_uh_set_connection_proxy($proxy2)))
		printf("[007] Expecting true got %s\n", var_export($tmp, true));

	$conn = mysqlnd_uh_test\connect::mysqli();
	$conn->query("SELECT 'global proxy'");

	class myproxy_connection extends myproxy {
		public function query($res, $sql) {
			printf("%s(%s, %s)\n", __METHOD__, var_export($res, true), var_export($sql, true));
			return parent::query($res, $sql);
		}
	}
	$proxy2 = new myproxy_connection();

	if (true !== ($tmp = mysqlnd_uh_set_connection_proxy($proxy2, $conn)))
		printf("[007] Expecting true got %s\n", var_export($tmp, true));

	$conn->query("SELECT 'connection proxy'");

	print "done!";
?>
--EXPECTF--
myproxy::init(NULL)
myproxy::query(NULL, 'SELECT \'global proxy\'')
myproxy_connection::query(NULL, 'SELECT \'connection proxy\'')
myproxy::query(NULL, 'SELECT \'connection proxy\'')
done!